﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class AudioManagement : MonoBehaviour
{
    static AudioManagement instance;
    public static AudioManagement Instance
    {
        get
        {
            return instance;
        }
        set
        {
            if (instance == null)
            {
                instance = value;
            }
        }
    }

    public AudioSource ambientSource;
    public AudioSource musicSource;
    public AudioSource raceMusicSource;

    AudioSource music
    {
        get
        {
            return HermitsManager.Instance.run ? raceMusicSource : musicSource;
        }
    }
    public AudioSource waveSound;
    public AudioSource buttonPlay;

    private void Awake()
    {
        Instance = this;
    }

    public bool noMore = false;

    public void SwitchToMusic()
    {
        if (noMore)
        {

        }
        else
        {
            noMore = true;
            StartCoroutine(volumeCoroutine());
        }
    }

    public void PlayJoin()
    {
        buttonPlay.Play();
    }

    IEnumerator volumeCoroutine()
    {
        ambientSource.volume = 1f;
        music.volume = 0f;
        music.Play();
        while (ambientSource.volume > 0f && music.volume  < 1f)
        {
            ambientSource.volume -= 0.05f;
            music.volume += 0.05f;
            yield return new WaitForSeconds(0.15f);
        }
        ambientSource.volume = 0f;
        music.volume = 1f;
    }
}
