﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class ClockUIManager : MonoBehaviour
{

    public Text ClockText;
    public RectTransform ClockPosition;

    private void Start()
    {
        HermitsManager.Instance.OnHermitSpawn += ChangeClockPosition;
    }

    public string SecondsToHoursMins(int secondsIn)
    {
        int min, sec;
        return SecondsToHoursMins(secondsIn, out min, out sec);
    }

    public string SecondsToHoursMins(int secondsIn, out int minutes, out int secondsOut)
    {
        minutes = secondsIn / 60;
        secondsOut = secondsIn - (minutes * 60);
        return minutes.ToString("00") + ":" + secondsOut.ToString("00");
    }

    private void ChangeClockPosition()
    {
        switch (HermitsManager.Instance.HermitsCount)
        {
            case 1:
                ClockPosition.anchorMin = new Vector2(0.5f, 1f);
                ClockPosition.anchorMax = new Vector2(0.5f, 1f);
                ClockPosition.pivot = new Vector2(0.5f, 1f);
                ClockPosition.anchoredPosition = Vector2.zero;
                break;
            case 2:
                ClockPosition.anchorMin = new Vector2(0.5f, 1f);
                ClockPosition.anchorMax = new Vector2(0.5f, 1f);
                ClockPosition.pivot = new Vector2(0.5f, 1f);
                ClockPosition.anchoredPosition = Vector2.zero;
                break;
            case 3:
                ClockPosition.anchorMin = new Vector2(0.75f, 0.25f);
                ClockPosition.anchorMax = new Vector2(0.75f, 0.25f);
                ClockPosition.pivot = new Vector2(0.5f, 0.5f);
                ClockPosition.anchoredPosition = Vector2.zero;
                break;
            case 4:
                ClockPosition.anchorMin = new Vector2(0.5f, 1f);
                ClockPosition.anchorMax = new Vector2(0.5f, 1f);
                ClockPosition.pivot = new Vector2(0.5f, 1f);
                ClockPosition.anchoredPosition = Vector2.zero;
                break;
        }
    }

    private void Update()
    {
        ClockText.text = SecondsToHoursMins((int)(HermitsManager.Instance.CurrentTime));
    }

}
