﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GiantWaveScript : MonoBehaviour
{
    Renderer myRenderer;

    public float currentPosition = 0f;
    public float minPos = -200f;
    public float maxPos = 200f;
    public float timePlaying = 1f;
    public float currentTime = 0f;
    public bool isPlaying = false;
    public bool isComing = false;

    void Awake()
    {
        myRenderer = GetComponent<Renderer>();
        if (myRenderer != null) myRenderer.enabled = false;
    }
    
    void Update()
    {
        if (isPlaying)
        {
            if (!isComing)
            {
                currentPosition = ((maxPos - minPos) * (currentTime / timePlaying)) - maxPos;
                if (myRenderer != null) myRenderer.material.SetFloat("_WaveX", currentPosition);
                currentTime += Time.deltaTime;
                if (currentTime > timePlaying) isPlaying = false;
            }
            else
            {
                currentPosition = ((maxPos - minPos) * ((timePlaying-currentTime) / timePlaying)) - maxPos;
                if (myRenderer != null) myRenderer.material.SetFloat("_WaveX", currentPosition);
                currentTime += Time.deltaTime;
                if (currentTime > timePlaying)
                {
                    if (isComing)
                    {
                        isComing = !isComing;
                        currentTime = 0f;
                        currentPosition = 0f;
                    }
                    else
                    {
                        isComing = !isComing;
                        isPlaying = false;
                        currentTime = 0f;
                        currentPosition = 0f;
                        if (myRenderer != null) myRenderer.enabled = false;
                    }
                }
            }
        }
    }

    public void PlayWave()
    {
        AudioManagement.Instance.waveSound.Play();
        isComing = true;
        isPlaying = true;
        currentTime = 0f;

        if(myRenderer!=null) myRenderer.enabled = true;
    }


}
