﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using DG.Tweening;

public class HermitCameraController : MonoBehaviour
{

    public Transform AttachedHermit;
    Camera thisCamera;

    private void Awake()
    {
        thisCamera = GetComponent<Camera>();
    }

    private void Update()
    {
        ControlCameraPosition();
        ControlCameraRotation();
        //transform.localPosition = AttachedHermit.position + new Vector3(-5, 5, 0);
        
    }

    float LastCameraMoveTime;
    Tweener positionTweener;

    private void ControlCameraPosition()
    {
        if (LastCameraMoveTime < 0 || Vector3.Distance(AttachedHermit.position, thisCamera.transform.position) > 0f)
        {
            //do logic
            DOTween.Kill(positionTweener);
            if (HermitsManager.Instance.run)
            {
                positionTweener = thisCamera.transform.DOMove(AttachedHermit.TransformPoint(new Vector3(0, 1.5f, -1.75f)), 1f);
            }
            else
            {
                positionTweener = thisCamera.transform.DOMove(AttachedHermit.TransformPoint(new Vector3(0, 0.5f, -0.75f)), 1f);
            }

            LastCameraMoveTime = Mathf.Clamp(LastCameraMoveTime + 0.5f, 0, 0.5f);
        }
        LastCameraMoveTime -= Time.deltaTime;
    }

    float LastCameraRotationTime;
    Vector3 currentLookPosion;
    Tweener rotationTweener;

    private void ControlCameraRotation()
    {
        if (LastCameraRotationTime < 0 || Vector3.Distance(currentLookPosion, AttachedHermit.position) > 0f)
        {
            //do logic
            currentLookPosion = AttachedHermit.position;
            DOTween.Kill(rotationTweener);
            rotationTweener = thisCamera.transform.DOLookAt(AttachedHermit.TransformPoint(Vector3.forward), 0.5f);
            LastCameraRotationTime = Mathf.Clamp(LastCameraRotationTime + 0.5f, 0, 0.5f);
        }
        LastCameraRotationTime -= Time.deltaTime;
    }


}
