﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;


public enum ArmorType { light, medium, heavy, plastic };
public enum ReductionType { zero, half, all, plastic };
public enum ReductionStep { first = 25, second = 75 };

public class Armor : PickupBase
{


    public ArmorType armorType;

    private float hpValue;
    public ReductionType damageRedution;
    private float percent = 100;

    public Material brokenArmorSkin;
    public MeshRenderer mesh;

    // Start is called before the first frame update
    void Start()
    {
        
    }

    // Update is called once per frame
    void Update()
    {
        
    }

    private void Awake()
    {
        this.hpValue = Params.Me.armorParams[this.armorType];
    }

    private float GetReductionValue()
    {
        return Params.Me.reductionParams[this.damageRedution] / percent;
    }

    private float GetArmorTypeValue()
    {
        return Params.Me.armorParams[this.armorType];
    }


    public float GetVelocityReductionValue()
    {
        switch (this.armorType)
        {
            case ArmorType.light:
                return 0.2f;
            case ArmorType.medium:
                return 0.4f;
            case ArmorType.heavy:
                return 0.6f;
            case ArmorType.plastic:
                return 0.4f;
        }
        return 0.0f;
    }

    public float GetRemainingHPValue()
    {
        return this.hpValue;
    }

  
    public int GetReducedHP(int value)
    {
        float reducedHP = value;
        switch (this.damageRedution)
        {
            case ReductionType.plastic:
                return 0;
            default:
                this.hpValue -= value * this.GetReductionValue();
                reducedHP = value - value * this.GetReductionValue();
                break;
        }

        if (this.hpValue > this.GetArmorTypeValue() * (int)ReductionStep.second / 100)
        {
            this.damageRedution = ReductionType.all;
        }
        else if (this.hpValue > this.GetArmorTypeValue() * (int)ReductionStep.first / 100)
        {
            this.damageRedution = ReductionType.half;
        }
        else
        {
            this.damageRedution = ReductionType.zero;
        }

        if (this.hpValue < this.GetArmorTypeValue() / 2 )
        {
            this.mesh.material = this.brokenArmorSkin;
        }

        return (int)reducedHP;
    }

  

}
