﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[ExecuteInEditMode]
public class PlayerSign : MonoBehaviour
{
    [Header("Movement params")]
    [SerializeField]
    private Transform model;

    [SerializeField]
    private bool moveY = true;
    [SerializeField]
    private float minY = 0.2f, maxY = 0.6f, speedY = 2f;

    [SerializeField]
    private bool rotateY = true;
    [SerializeField]
    private float rotateSpeedY = 2f;

    void Start()
    {
        if (model == null)
            model = transform.GetChild(0);
    }

    void Update()
    {
        if (moveY)
            model.localPosition = new Vector3(0f, (maxY - minY) * 0.5f * Mathf.Sin(Time.unscaledTime * speedY) + minY + (maxY - minY) * 0.5f);
        if (rotateY)
            model.localEulerAngles += new Vector3(0f, Time.unscaledDeltaTime * rotateSpeedY * Mathf.Rad2Deg);
    }
}