﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class RaceGameManager : MonoBehaviour
{
    static RaceGameManager instance;
    public static RaceGameManager Instance
    {
        get
        {
            if (instance == null) instance = FindObjectOfType<RaceGameManager>();
            return instance;
        }
        set
        {
            if (instance == null)
            {
                instance = value;
            }
        }
    }

    List<Transform> playerRespawnPoints = new List<Transform>();
    public Transform playerRespawnRoot;


    private void Awake()
    {
        for (int i = 0; i < playerRespawnRoot.childCount; ++i)
        {
            playerRespawnPoints.Add(playerRespawnRoot.GetChild(i));
        }
    }

    public Transform GetClosestRespawn(HermitController player)
    {
        Transform ret = player.transform;
        float distance = float.PositiveInfinity;
        float currentDistance = 0;
        foreach (Transform t in playerRespawnPoints)
        {
            currentDistance = Vector3.Distance(t.position, player.transform.position);
            if (currentDistance < distance)
            {
                ret = t;
                distance = currentDistance;
            }
        }
        return ret;
    }
}
