﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using DG.Tweening;

public class UIHealthBar : MonoBehaviour
{
    [SerializeField]
    private Image hpSlider;

    private Tweener hpTween;

    int minValue, maxValue, value;

    [SerializeField]
    private Image heartImage, lifeImage;

    [SerializeField]
    private Sprite redHeart, greenHeart, redLife, greenLife;

    public void Show()
    {
        gameObject.SetActive(true);
    }

    public void Hide()
    {
        gameObject.SetActive(false);
    }

    public void Init(int maxHP)
    {
        minValue = 0;
        maxValue = maxHP;
        value = maxHP;
        hpSlider.fillAmount = (float)value / maxValue;
    }

    public void Refresh(int currentHP, Armor currentArmor)
    {
        value = currentHP;
        if (hpTween != null)
            hpTween.Complete();
        hpTween = hpSlider.DOFillAmount((float)value / maxValue, 0.5f);

        if(currentArmor == null)
        {
            heartImage.sprite = redHeart;
            lifeImage.sprite = redLife;
        }
        else
        {
            switch(currentArmor.armorType)
            {
                case ArmorType.plastic:
                    heartImage.sprite = greenHeart;
                    lifeImage.sprite = greenLife;
                    break;
                default:
                    heartImage.sprite = redHeart;
                    lifeImage.sprite = redLife;
                    break;
            }
        }
    }
}
